From fdd0a196ef612012c6115ecc1ac035da3af25d60 Mon Sep 17 00:00:00 2001
From: Niklas Haas <git@haasn.dev>
Date: Wed, 13 Aug 2025 15:45:51 +0200
Subject: [PATCH 34/37] avfilter/drawutils: add alpha mode support

This allows drawing colors onto images with premultiplied alpha, by first
premultiplying the specified RGBA values.
---
 libavfilter/drawutils.c    | 12 +++++++++---
 libavfilter/drawutils.h    |  3 ++-
 libavfilter/vf_subtitles.c |  2 +-
 3 files changed, 12 insertions(+), 5 deletions(-)

diff --git a/libavfilter/drawutils.c b/libavfilter/drawutils.c
index f7e3adf9e8..75bf8f4755 100644
--- a/libavfilter/drawutils.c
+++ b/libavfilter/drawutils.c
@@ -94,7 +94,7 @@ int ff_fill_ayuv_map(uint8_t *ayuv_map, enum AVPixelFormat pix_fmt)
 }
 
 int ff_draw_init2(FFDrawContext *draw, enum AVPixelFormat format, enum AVColorSpace csp,
-                  enum AVColorRange range, unsigned flags)
+                  enum AVColorRange range, enum AVAlphaMode alpha, unsigned flags)
 {
     const AVPixFmtDescriptor *desc = av_pix_fmt_desc_get(format);
     const AVLumaCoefficients *luma = NULL;
@@ -155,6 +155,7 @@ int ff_draw_init2(FFDrawContext *draw, enum AVPixelFormat format, enum AVColorSp
     draw->nb_planes = nb_planes;
     draw->range     = range;
     draw->csp       = csp;
+    draw->alpha     = alpha;
     draw->flags     = flags;
     if (luma)
         ff_fill_rgb2yuv_table(luma, draw->rgb2yuv);
@@ -167,12 +168,12 @@ int ff_draw_init2(FFDrawContext *draw, enum AVPixelFormat format, enum AVColorSp
 int ff_draw_init_from_link(FFDrawContext *draw, const AVFilterLink *link,
                            unsigned flags)
 {
-    return ff_draw_init2(draw, link->format, link->colorspace, link->color_range, flags);
+    return ff_draw_init2(draw, link->format, link->colorspace, link->color_range, link->alpha_mode, flags);
 }
 
 int ff_draw_init(FFDrawContext *draw, enum AVPixelFormat format, unsigned flags)
 {
-    return ff_draw_init2(draw, format, AVCOL_SPC_UNSPECIFIED, AVCOL_RANGE_UNSPECIFIED, flags);
+    return ff_draw_init2(draw, format, AVCOL_SPC_UNSPECIFIED, AVCOL_RANGE_UNSPECIFIED, AVALPHA_MODE_UNSPECIFIED, flags);
 }
 
 void ff_draw_color(FFDrawContext *draw, FFDrawColor *color, const uint8_t rgba[4])
@@ -189,6 +190,11 @@ void ff_draw_color(FFDrawContext *draw, FFDrawColor *color, const uint8_t rgba[4
     for (int i = 0; i < 4; i++)
         rgbad[i] = color->rgba[i] / 255.;
 
+    if (draw->alpha == AVALPHA_MODE_PREMULTIPLIED) {
+        for (int i = 0; i < 3; i++)
+            rgbad[i] *= rgbad[3];
+    }
+
     if (draw->desc->flags & AV_PIX_FMT_FLAG_RGB)
         memcpy(yuvad, rgbad, sizeof(double) * 3);
     else
diff --git a/libavfilter/drawutils.h b/libavfilter/drawutils.h
index c68a78e84b..a7fc967a85 100644
--- a/libavfilter/drawutils.h
+++ b/libavfilter/drawutils.h
@@ -45,6 +45,7 @@ typedef struct FFDrawContext {
     enum AVColorRange range;
     unsigned flags;
     enum AVColorSpace csp;
+    enum AVAlphaMode alpha;
     double rgb2yuv[3][3];
 } FFDrawContext;
 
@@ -78,7 +79,7 @@ typedef struct FFDrawColor {
  * @return        0 for success, < 0 for error
  */
 int ff_draw_init2(FFDrawContext *draw, enum AVPixelFormat format, enum AVColorSpace csp,
-                  enum AVColorRange range, unsigned flags);
+                  enum AVColorRange range, enum AVAlphaMode alpha, unsigned flags);
 
 /**
  * Init a draw context, taking the format, colorspace and range from the given
diff --git a/libavfilter/vf_subtitles.c b/libavfilter/vf_subtitles.c
index cf23b7822a..dde45357ce 100644
--- a/libavfilter/vf_subtitles.c
+++ b/libavfilter/vf_subtitles.c
@@ -189,7 +189,7 @@ static int config_input(AVFilterLink *inlink)
     ret = ff_draw_init2(&ass->draw, inlink->format,
                         ass_get_color_space(ass->track->YCbCrMatrix, inlink->colorspace),
                         ass_get_color_range(ass->track->YCbCrMatrix, inlink->color_range),
-                        ass->alpha ? FF_DRAW_PROCESS_ALPHA : 0);
+                        inlink->alpha_mode, ass->alpha ? FF_DRAW_PROCESS_ALPHA : 0);
     if (ret < 0) {
         av_log(ctx, AV_LOG_ERROR, "Failed to initialize FFDrawContext\n");
         return ret;
-- 
2.49.1


